package it.micegroup.gestioneferie.pianificazioneferie.service;

import java.util.Map;
import java.util.List;
import java.util.Locale;
import java.util.HashMap;
import java.util.Optional;
import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;

import org.springframework.context.i18n.LocaleContextHolder;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import net.sf.jasperreports.engine.JRParameter;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePf;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePfKey;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiAdesionePf;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePf;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiAdesionePfKey;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePfKey;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.criteria.DesitiRichAdesionePfCriteria;
import it.micegroup.gestioneferie.pianificazioneferie.repository.DesitiRichAdesionePfRepository;
import it.micegroup.voila2runtime.specification.FilterService;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePfKey_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiAdesionePfKey_;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePfKey_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePfKey_;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DpianiFerie_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiPianoFerie_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiPianoFerieKey_;

import org.springframework.data.domain.PageImpl;
import lombok.RequiredArgsConstructor;
import it.micegroup.gestioneferie.libs.service.BaseServiceImpl;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePfKey_;

import java.util.stream.Collectors;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DpianificFerieAmmto;
import it.micegroup.voila2runtime.entity.GenericEntity;
import it.micegroup.voila2runtime.exception.BusinessException;
import net.sf.jasperreports.engine.JRException;

@RequiredArgsConstructor
@Service
@Transactional
public class DesitiRichAdesionePfServiceImpl extends BaseServiceImpl implements DesitiRichAdesionePfService {

	private final DesitiRichAdesionePfRepository desitiRichAdesionePfRepository;
	private final FilterService<DesitiRichAdesionePf> filterService;

	// CHILD SERVICES
	private final DpianificFerieAmmtoService dpianificFerieAmmtoService;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DesitiRichAdesionePfServiceImpl.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findAll(org. springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DesitiRichAdesionePf> findAll(Pageable pageable) {
		return desitiRichAdesionePfRepository.findAll(pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findAll()
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DesitiRichAdesionePf> findAll() {
		return desitiRichAdesionePfRepository.findAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByCriteria(java. lang.Object, org.springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DesitiRichAdesionePf> findByCriteria(DesitiRichAdesionePfCriteria criteria, Pageable pageable) {
		final Specification<DesitiRichAdesionePf> specification = createSpecification(criteria);
		return desitiRichAdesionePfRepository.findAll(specification, pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByCriteria(java. lang.Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DesitiRichAdesionePf> findByCriteria(DesitiRichAdesionePfCriteria criteria) {
		final Specification<DesitiRichAdesionePf> specification = createSpecification(criteria);
		return desitiRichAdesionePfRepository.findAll(specification);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findById(java.lang. Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DesitiRichAdesionePf> findById(DesitiRichAdesionePfKey id) {
		return desitiRichAdesionePfRepository.findByDesitiRichAdesionePfKey(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * exists(java.lang. Object)
	 */
	@Override
	public boolean exists(DesitiRichAdesionePfKey id) {
		return desitiRichAdesionePfRepository.existsById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * insert(java. lang.Object)
	 */
	@Override
	public DesitiRichAdesionePf insert(@Valid DesitiRichAdesionePf entity) {
		return desitiRichAdesionePfRepository.save(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * update(java. lang.Object)
	 */
	@Override
	public DesitiRichAdesionePf update(@Valid DesitiRichAdesionePf entity) {
		return desitiRichAdesionePfRepository.save(entity);
	}

	@Override
	public void delete(DesitiRichAdesionePf entity) {
		desitiRichAdesionePfRepository.delete(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * deleteById(java.lang. Object)
	 */
	@Override
	public void deleteById(DesitiRichAdesionePfKey id) {
		desitiRichAdesionePfRepository.deleteById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * deleteByIdIn(java.lang. Object)
	 */
	@Override
	public void deleteByIdIn(Collection<DesitiRichAdesionePfKey> ids) {
		desitiRichAdesionePfRepository.deleteByIdIn(ids);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByObjectKey(java.lang.String)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DesitiRichAdesionePf> findByObjectKey(String id) {
		DesitiRichAdesionePf desitiRichAdesionePf = new DesitiRichAdesionePf(id);

		return findById(desitiRichAdesionePf.getDesitiRichAdesionePfKey());
	}

	@Override
	public Page<DesitiRichAdesionePf> findByTheDstatiAdesionePf(DstatiAdesionePf parentEntity, Pageable pageable) {
		return desitiRichAdesionePfRepository.findByTheDstatiAdesionePf(parentEntity, pageable);
	}

	@Override
	public Page<DesitiRichAdesionePf> findByTheDrichAdesionePf(DrichAdesionePf parentEntity, Pageable pageable) {
		return desitiRichAdesionePfRepository.findByTheDrichAdesionePf(parentEntity, pageable);
	}

	/**
	 * Convert DesitiRichAdesionePfCriteria to a {@link Specification}
	 * 
	 * @param criteria
	 * @return
	 */
	private Specification<DesitiRichAdesionePf> createSpecification(DesitiRichAdesionePfCriteria criteria) {
		Specification<DesitiRichAdesionePf> specification = Specification.where(null);

		if (criteria != null) {
			// Attribute filters
			if (criteria.getSequIdEsitoRichAdesionePf() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getSequIdEsitoRichAdesionePf(), DesitiRichAdesionePf_.sequIdEsitoRichAdesionePf));
			}
			if (criteria.getFkAmministrato() != null) {
				specification = specification.and(filterService.generateRangeSpecification(criteria.getFkAmministrato(),
						DesitiRichAdesionePf_.fkAmministrato));
			}
			if (criteria.getFkRichAdesionePf() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkRichAdesionePf(), DesitiRichAdesionePf_.fkRichAdesionePf));
			}
			if (criteria.getFkStatoRichAdesione() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getFkStatoRichAdesione(), DesitiRichAdesionePf_.fkStatoRichAdesione));
			}
			if (criteria.getFlagEliminato() != null) {
				specification = specification.and(filterService.generateStringSpecification(criteria.getFlagEliminato(),
						DesitiRichAdesionePf_.flagEliminato));
			}
			if (criteria.getUtenteUltimaModifica() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getUtenteUltimaModifica(), DesitiRichAdesionePf_.utenteUltimaModifica));
			}
			if (criteria.getDataUltimaModifica() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataUltimaModifica(), DesitiRichAdesionePf_.dataUltimaModifica));
			}
			if (criteria.getDataInizioRecord() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataInizioRecord(), DesitiRichAdesionePf_.dataInizioRecord));
			}
			if (criteria.getDataFineRecord() != null) {
				specification = specification.and(filterService.generateRangeSpecification(criteria.getDataFineRecord(),
						DesitiRichAdesionePf_.dataFineRecord));
			}

			// CompositeKey Filters

			if (criteria.getTheDstatiAdesionePfObjectKey() != null) {
				DstatiAdesionePf dstatiAdesionePf = new DstatiAdesionePf(criteria.getTheDstatiAdesionePfObjectKey());

			}
			if (criteria.getTheDrichAdesionePfObjectKey() != null) {
				DrichAdesionePf drichAdesionePf = new DrichAdesionePf(criteria.getTheDrichAdesionePfObjectKey());

			}

		}
		return specification;
	}

	/*
	 * 
	 * @see it.micegroup.gestioneferie.pianificazioneferie.service.
	 * DesitiRichAdesionePfService#findDstatiAdesionePfBytheDrichAdesionePf(it.
	 * micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePf,
	 * org.springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DstatiAdesionePf> findDstatiAdesionePfByTheDrichAdesionePf(DrichAdesionePf drichAdesionePf,
			Pageable pageable) {
		Page<DesitiRichAdesionePf> desitiRichAdesionePfPage = desitiRichAdesionePfRepository
				.findByTheDrichAdesionePf(drichAdesionePf, pageable);
		List<DstatiAdesionePf> content = desitiRichAdesionePfPage.getContent().stream()
				.map(DesitiRichAdesionePf::getTheDstatiAdesionePf).collect(Collectors.toList());
		Page<DstatiAdesionePf> result = new PageImpl<DstatiAdesionePf>(content, pageable,
				desitiRichAdesionePfPage.getTotalElements());
		return result;
	}

	/*
	 * 
	 * @see it.micegroup.gestioneferie.pianificazioneferie.service.
	 * DesitiRichAdesionePfService#findDrichAdesionePfBytheDstatiAdesionePf(it.
	 * micegroup.gestioneferie.pianificazioneferie.entity.DstatiAdesionePf,
	 * org.springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DrichAdesionePf> findDrichAdesionePfByTheDstatiAdesionePf(DstatiAdesionePf dstatiAdesionePf,
			Pageable pageable) {
		Page<DesitiRichAdesionePf> desitiRichAdesionePfPage = desitiRichAdesionePfRepository
				.findByTheDstatiAdesionePf(dstatiAdesionePf, pageable);
		List<DrichAdesionePf> content = desitiRichAdesionePfPage.getContent().stream()
				.map(DesitiRichAdesionePf::getTheDrichAdesionePf).collect(Collectors.toList());
		Page<DrichAdesionePf> result = new PageImpl<DrichAdesionePf>(content, pageable,
				desitiRichAdesionePfPage.getTotalElements());
		return result;
	}

	@Override
	@Transactional()
	public DesitiRichAdesionePf bulkUpdate(DesitiRichAdesionePf desitiRichAdesionePf) {
		List<DpianificFerieAmmto> updateTheDpianificFerieAmmto = desitiRichAdesionePf.getTheDpianificFerieAmmto()
				.stream().filter(child -> !child.isDeletedEntityState()).collect(Collectors.toList());
		List<DpianificFerieAmmto> deleteTheDpianificFerieAmmto = desitiRichAdesionePf.getTheDpianificFerieAmmto()
				.stream().filter(GenericEntity::isDeletedEntityState).collect(Collectors.toList());

		desitiRichAdesionePf.setTheDpianificFerieAmmto(updateTheDpianificFerieAmmto);

		DesitiRichAdesionePf update = this.update(desitiRichAdesionePf);

		deleteTheDpianificFerieAmmto
				.forEach(child -> dpianificFerieAmmtoService.deleteById(child.getDpianificFerieAmmtoKey()));
		return update;
	}
}
